<!DOCTYPE html>
<html lang="en">

<head>
    <title>Order Manager</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.1/css/all.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.1/css/jquery.dataTables.css">
    <script src="https://cdn.datatables.net/1.13.1/js/jquery.dataTables.js"></script>
</head>

<body>
    <div class="container p-2">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3><b>DANH SÁCH ĐƠN HÀNG</b></h3>
            </div>
        </div>
        <!-- FILTER DATA -->
        <div class="row form-group bg-light p-3 rounded">
            <div class="col-sm-2">
                <label class="col-form-label"><b>Trạng thái Order</b></label>
            </div>
            <div class="col-sm-3">
                <select id="select-status" class="form-control">
                    <option value="">Chọn trạng thái order</option>
                    <option value="Open">Open</option>
                    <option value="Confirmed">Confirmed</option>
                    <option value="Cancel">Cancel</option>
                </select>
            </div>
            <div class="col-sm-2">
                <label class="col-form-label"><b>Loại Pizza</b></label>
            </div>
            <div class="col-sm-3">
                <select id="select-pizza" class="form-control">
                    <option value="">Chọn loại pizza</option>
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Bacon</option>
                    <option value="Seafood">Seafood</option>
                </select>
            </div>
            <div class="col-sm-2">
                <button id="btn-filter" class="btn btn-success w-100">Filter Data &nbsp; <i class="fa-solid fa-filter"></i></button>
            </div>
        </div>
        <!-- END FILTER DATA -->
        <div class="row form-group">
            <div class="col-sm-12">
                <!-- TABLE ORDER -->
                <table id="order-table" class="table table-bordered table-striped table-hover">
                    <thead>
                        <tr>
                            <th>Mã đơn</th>
                            <th>Combo</th>
                            <th>Pizza</th>
                            <th>Drink</th>
                            <th>Thành tiền</th>
                            <th>Họ và tên</th>
                            <th>Điện thoại</th>
                            <th>Trạng thái</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody></tbody>
                </table>
                <!-- END TABLE ORDER -->
            </div>
        </div>
    </div>
    <!-- MODAL ORDER DETAIL -->
    <div id="modal-order-detail" class="modal fade">
        <div class="modal-dialog modal-xl">
            <div class="modal-content">
                <!-- Header -->
                <div class="modal-header">
                    <h4>ORDER DETAIL</h4>
                    <a role="button" class="close" data-dismiss="modal">&times;</a>
                </div>
                <!-- Body -->
                <div class="modal-body">
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Mã đơn</label>
                        <div class="col-4">
                            <input id="input-ma-don" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Kích cỡ</label>
                        <div class="col-4">
                            <input id="input-kich-co" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Đường kính</label>
                        <div class="col-4">
                            <input id="input-duong-kinh" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Sườn</label>
                        <div class="col-4">
                            <input id="input-suon" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Salad</label>
                        <div class="col-4">
                            <input id="input-salad" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Loại Pizza</label>
                        <div class="col-4">
                            <input id="input-loai-pizza" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Voucher</label>
                        <div class="col-4">
                            <input id="input-voucher" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Thành tiền</label>
                        <div class="col-4">
                            <input id="input-thanh-tien" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Giảm giá</label>
                        <div class="col-4">
                            <input id="input-giam-gia" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Nước uống</label>
                        <div class="col-4">
                            <input id="input-drink" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Số lượng nước</label>
                        <div class="col-4">
                            <input id="input-drink-number" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Họ và tên</label>
                        <div class="col-4">
                            <input id="input-fullname" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Email</label>
                        <div class="col-4">
                            <input id="input-email" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Điện thoại</label>
                        <div class="col-4">
                            <input id="input-phone" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Địa chỉ</label>
                        <div class="col-4">
                            <input id="input-address" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Lời nhắn</label>
                        <div class="col-4">
                            <input id="input-message" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Trạng thái</label>
                        <div class="col-4">
                            <input id="input-status" class="form-control">
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-2 col-form-label">Ngày tạo</label>
                        <div class="col-4">
                            <input id="input-day-create" class="form-control">
                        </div>
                        <label class="col-2 col-form-label">Ngày cập nhật</label>
                        <div class="col-4">
                            <input id="input-day-modify" class="form-control">
                        </div>
                    </div>
                    <hr>
                    <div class="row">
                        <div class="col-6">
                            <button id="btn-confirm" class="btn btn-success w-100">Confirm Order</button>
                        </div>
                        <div class="col-6">
                            <button id="btn-cancel" class="btn btn-danger w-100">Cancel Order</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- END MODAL ORDER DETAIL -->
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    var gOrderList = [];
    var gOrderId = "";
    var gOrderCode = "";
    
    const gTABLE_ROW = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
    const gCODE_COL = 0;
    const gCOMBO_COL = 1;
    const gPIZZA_COL = 2;
    const gDRINK_COL = 3;
    const gTOTAL_COL = 4;
    const gNAME_COL = 5;
    const gPHONE_COL = 6;
    const gSTATUS_COL = 7;
    const gACTION_COL = 8;
    
    var gTableOrder = $("#order-table").DataTable({
        columns: [
            {data: gTABLE_ROW[gCODE_COL]},
            {data: gTABLE_ROW[gCOMBO_COL]},
            {data: gTABLE_ROW[gPIZZA_COL]},
            {data: gTABLE_ROW[gDRINK_COL]},
            {data: gTABLE_ROW[gTOTAL_COL]},
            {data: gTABLE_ROW[gNAME_COL]},
            {data: gTABLE_ROW[gPHONE_COL]},
            {data: gTABLE_ROW[gSTATUS_COL]},
            {data: gTABLE_ROW[gACTION_COL]},
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent: '<button id="btn-detail" class="btn btn-success w-100">Detail</button>'
            }
        ]
    })

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện tải trang/F5
    $(document).ready(onPageLoading);

    // gán sự kiện click button Filter
    $(document).on("click", "#btn-filter", onBtnFilterClick);

    // gán sự kiện click button Detail
    $(document).on("click", "#btn-detail", onBtnDetailClick);
    // gán sự kiện click button Confirm Order trên Modal Order Detail
    $(document).on("click", "#btn-confirm", onBtnConfirmOrderClick);
    // gán sự kiện click button Cancel Order trên Modal Order Detail
    $(document).on("click", "#btn-cancel", onBtnCancelOrderClick);
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
        // Gọi API lấy danh sách đơn hàng và lưu vào biến toàn cục gOrderList
        apiGetOrderList();
        // Xử lý hiển thị
        insertOrderListToTable(gOrderList);
    }

    // function xử lý sự kiện click button Filter
    function onBtnFilterClick() {
        // Khai báo đối tượng chứa dữ liệu filter
        let vFilterData = {
            trangThai: "",
            loaiPizza: "",
        };
        // Thu thập dữ liệu
        getFilterData(vFilterData);
        console.log(vFilterData);
        // Kiểm tra dữ liệu
        // Xử lý hiển thị
        let vResultData = getFilteredDataObject(vFilterData);
        insertOrderListToTable(vResultData);
    }

    // function xử lý sự kiện click button Detail (Chi tiết)
    function onBtnDetailClick() {
        // hiện modal Order Detail
        $("#modal-order-detail").modal("show");
        // thu thập dữ liệu ID và Order code lưu vào biến toàn cục
        getUserDetailOnClick(this);
        // gọi API lấy thông tin đơn hàng bằng order code
        let vAjaxRequest = apiGetOrderDetailByOrderCode();
        vAjaxRequest.done(function(orderDetail) {
            // Xử lý hiển thị dữ liệu
            displayOrderDetail(orderDetail);
        });
    }

    // function xử lý sự kiện click button Confirm Order trên Modal Order Detail
    function onBtnConfirmOrderClick() {
        // Thu thập dữ liệu trạng thái:
        let vOrderConfirm = {trangThai: "confirmed"};
        // Gọi API update đơn hàng
        let vAjaxRequest = apiUpdateOrder(vOrderConfirm);
        vAjaxRequest.done(function() {
            // Xử lý hiển thị
            handleConfirmOrderSuccess();
        });
    }

    // function xử lý sự kiện click button Cancel Order trên Modal Order Detail
    function onBtnCancelOrderClick() {
        // Thu thập dữ liệu trạng thái:
        let vOrderCancel = {trangThai: "cancel"};
        // Gọi API update đơn hàng
        let vAjaxRequest = apiUpdateOrder(vOrderCancel);
        vAjaxRequest.done(function() {
            // Xử lý hiển thị
            handleCancelOrderSuccess();
        });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function gọi API lấy thông tin đơn hàng bằng order code
    function apiGetOrderDetailByOrderCode() {
        return $.ajax({
            url:gBASE_URL + "/" + gOrderCode,
            type: "GET",
        });
    }

    // function gọi API lấy danh sách đơn hàng và lưu vào biến toàn cục gOrderList 
    function apiGetOrderList() {
        return $.ajax({
            url: gBASE_URL,
            type: "GET",
            async: false,
        }).done(function(orderList) {
            gOrderList = orderList;
        }).fail(function(error) {
            console.log("Lấy dữ liệu Order List không thành công");
        });
    }

    // function gọi API để cập nhật trạng thái confirm hoặc cancel cho 01 order (update)
    function apiUpdateOrder(paramStatus) {
        return $.ajax({
            url: gBASE_URL + "/" + gOrderId,
            type: "PUT",
            data: JSON.stringify(paramStatus),
            contentType: "application/json",
        });
    }

    // function insert danh sách đơn hàng vào table
    function insertOrderListToTable(paramOrderList) {
        gTableOrder.clear();
        gTableOrder.rows.add(paramOrderList);
        gTableOrder.draw();
    }

    // function thu thập dữ liệu filter
    // function return tham số đối tượng paramFilterData chứa dữ liệu người dùng chọn trên form
    function getFilterData(paramFilterData) {
        paramFilterData.trangThai = $("#select-status").val();
        paramFilterData.loaiPizza = $("#select-pizza").val();
    }

    // function xử lý filter data theo firstname và lastname
    function getFilteredDataObject(paramFilterData) {
        let vFilteredData = gOrderList.filter(function(order) {
            return (order.trangThai.toLowerCase() == paramFilterData.trangThai.toLowerCase() || paramFilterData.trangThai == "") 
                && (order.loaiPizza.toLowerCase() == paramFilterData.loaiPizza.toLowerCase() || paramFilterData.loaiPizza == "");
        })
        return vFilteredData;
    }

    // function thu thập dữ liệu của Row khi click button Detail
    function getUserDetailOnClick(paramButton) {
        let vRowClicked = $(paramButton).closest("tr");
        let vUserData = gTableOrder.row(vRowClicked).data();
        gOrderCode = vUserData.orderCode;
        gOrderId = vUserData.id;
    }

    // function hiển thị dữ liệu order detail lên Modal Order Detail
    function displayOrderDetail(paramOrderDetail) {
        $("#input-ma-don").val(paramOrderDetail.orderCode);
        $("#input-kich-co").val(paramOrderDetail.kichCo);
        $("#input-duong-kinh").val(paramOrderDetail.duongKinh);
        $("#input-suon").val(paramOrderDetail.suon);
        $("#input-salad").val(paramOrderDetail.salad);
        $("#input-loai-pizza").val(paramOrderDetail.loaiPizza);
        $("#input-voucher").val(paramOrderDetail.idVourcher);
        $("#input-thanh-tien").val(paramOrderDetail.thanhTien);
        $("#input-giam-gia").val(paramOrderDetail.giamGia);
        $("#input-drink").val(paramOrderDetail.idLoaiNuocUong);
        $("#input-drink-number").val(paramOrderDetail.soLuongNuoc);
        $("#input-fullname").val(paramOrderDetail.hoTen);
        $("#input-email").val(paramOrderDetail.email);
        $("#input-phone").val(paramOrderDetail.soDienThoai);
        $("#input-address").val(paramOrderDetail.diaChi);
        $("#input-message").val(paramOrderDetail.loiNhan);
        $("#input-status").val(paramOrderDetail.trangThai);
        $("#input-day-create").val(paramOrderDetail.ngayTao);
        $("#input-day-modify").val(paramOrderDetail.ngayCapNhat);
    }

    // function xử lý hiển thị Confirm đơn hàng thành công
    function handleConfirmOrderSuccess() {
        $("#modal-order-detail").modal("hide");
        alert("Confirm đơn hàng thành công");
        // Tải lại order list và tải lại table data
        apiGetOrderList();
        insertOrderListToTable(gOrderList);
    }

    // function xử lý hiển thị Cancel đơn hàng thành công
    function handleCancelOrderSuccess() {
        $("#modal-order-detail").modal("hide");
        alert("Cancel đơn hàng thành công");
        // Tải lại order list và tải lại table data
        apiGetOrderList();
        insertOrderListToTable(gOrderList);
    }

</script>

</html>